#include "IceInclude.h"
#include <iostream>
#include "Client.h"
#include "Printer.h"
using namespace std;
using namespace testICE;

int Client::run(int argc, char* argv[])
{
	if(argc > 1)
	{
		cerr << appName() << ": too many arguments" << endl;
		return EXIT_FAILURE;
	}

    Ice::CommunicatorPtr ic;
    try
    {
        ic = Ice::initialize(argc, argv);
        Ice::ObjectPrx base = ic->stringToProxy("server:tcp -h 192.168.2.61 -p 7777");
        PrinterPrx printer = PrinterPrx::checkedCast(base);
        if( !printer )
            throw "Invalid proxy";
        printer->printString("ZMQ Hello Word!");
    }
    catch(const Ice::Exception& ex)
    {
        cerr<<ex<<endl;
    }
    catch(const char* msg)
    {
        cerr<<msg<<endl;
    }

    if(ic)
        ic->destroy();

	return EXIT_SUCCESS;
}
