#include "Server.h"
#include "PrinterI.h"

int Server::run(int argc, char* argv[])
{
	if(argc > 1)
	{
		cerr << appName() << ": too many arguments" << endl;
		return EXIT_FAILURE;
	}

	try
	{
        // adapter
        m_adapter = communicator()->createObjectAdapterWithEndpoints("TestICE", "default -p 7777");
        CPrinterIPtr printerptr = new CPrinterI();
        m_adapter->add( printerptr, communicator()->stringToIdentity("server") );
        m_adapter->activate();
		communicator()->waitForShutdown();
	}
	catch (const Ice::Exception& e)
	{
		cerr<<e<<endl;
	}

	if (communicator()) {
		try {
			communicator()->destroy();
		} catch (const Ice::Exception& e) {
			cerr << e << endl;
		}
	}

	return EXIT_SUCCESS;
}
